

import * as Decco from "../node_modules/decco/src/Decco.bs.js";
import * as Js_dict from "../node_modules/bs-platform/lib/es6/js_dict.js";
import * as Js_json from "../node_modules/bs-platform/lib/es6/js_json.js";
import * as Belt_Option from "../node_modules/bs-platform/lib/es6/belt_Option.js";

function score_encode(v) {
  return Js_dict.fromArray([
              [
                "name",
                Decco.stringToJson(v.name)
              ],
              [
                "time",
                Decco.stringToJson(v.time)
              ]
            ]);
}

function score_decode(v) {
  var dict = Js_json.classify(v);
  if (typeof dict === "number") {
    return Decco.error(undefined, "Not an object", v);
  }
  if (dict.TAG !== /* JSONObject */2) {
    return Decco.error(undefined, "Not an object", v);
  }
  var dict$1 = dict._0;
  var name = Decco.stringFromJson(Belt_Option.getWithDefault(Js_dict.get(dict$1, "name"), null));
  if (name.TAG === /* Ok */0) {
    var time = Decco.stringFromJson(Belt_Option.getWithDefault(Js_dict.get(dict$1, "time"), null));
    if (time.TAG === /* Ok */0) {
      return {
              TAG: /* Ok */0,
              _0: {
                name: name._0,
                time: time._0
              }
            };
    }
    var e = time._0;
    return {
            TAG: /* Error */1,
            _0: {
              path: ".time" + e.path,
              message: e.message,
              value: e.value
            }
          };
  }
  var e$1 = name._0;
  return {
          TAG: /* Error */1,
          _0: {
            path: ".name" + e$1.path,
            message: e$1.message,
            value: e$1.value
          }
        };
}

function getName(score) {
  return score.name;
}

function getTime(score) {
  return score.time;
}

function score_api_response_encode(v) {
  return Decco.arrayToJson(score_encode, v);
}

function score_api_response_decode(v) {
  return Decco.arrayFromJson(score_decode, v);
}

export {
  score_encode ,
  score_decode ,
  getName ,
  getTime ,
  score_api_response_encode ,
  score_api_response_decode ,
  
}
/* No side effect */
